#include <stdio.h>
#include <stdlib.h>

typedef struct {
    int r,c,val;
}element;

typedef struct {
    int m,n;
    int nrelem;
    element *t;
}matrice;

matrice* citeste()
{
    matrice *mat = (matrice*)malloc(sizeof(matrice));
    printf("Nr.linii=");
    scanf("%d",&mat->m);
    printf("Nr.coloane=");
    scanf("%d",&mat->n);
    printf("Nr.elemente=");
    scanf("%d",&mat->nrelem);
    mat->t = (element*)malloc(mat->nrelem * sizeof(element));
    for (int i=0; i<mat->nrelem; i++)
    {
        printf("Element (rand,coloana,valoare) = ");
        scanf(" (%d,%d,%d)", &mat->t[i].r, &mat->t[i].c, &mat->t[i].val);
    }
    return mat;
}

element* corespondent(element* x, matrice *a)
{
    for (int i=0; i<a->nrelem; i++)
        if (x->r == a->t[i].r && x->c == a->t[i].c)
            return a->t + i;

    return NULL;
}

matrice* suma (matrice* a, matrice* b)
{
    if (a->m!=b->m || a->n!=b->n)
        return NULL; // return 0;

    matrice *c = (matrice*)malloc(sizeof(matrice));
    c->m = a->m;
    c->n = a->n;
    c->t = (element*)malloc((a->nrelem + b->nrelem) * sizeof(element));
    c->nrelem=0;

    for (int i=0; i<a->nrelem; i++)
    {
        element *e = corespondent(a->t+i, b);
        if (e==NULL)
        {
            c->t[c->nrelem] = a->t[i];
            (c->nrelem)++;
        }
        else {
            int suma= a->t[i].val + e->val;
            if (suma!=0)
            {
                c->t[c->nrelem].r = e->r;
                c->t[c->nrelem].c = e->c;
                c->t[c->nrelem].val = suma;
                (c->nrelem)++;
            }
        }
    }

    for (int i=0; i<b->nrelem; i++)
    {
        element *e = corespondent(b->t+i, a);
        if (e==NULL)
        {
            c->t[c->nrelem] = b->t[i];
            (c->nrelem)++;
        }
    }

    return c;
}

void afiseaza(matrice *x)
{
    if (x==NULL)
        printf("MATRICE INEXISTENTA!!!");
    else
        for (int i=0; i<x->nrelem; i++)
            printf("(%d,%d,%d)\n", x->t[i].r, x->t[i].c, x->t[i].val);
}

void dezaloca(matrice *x)
{
    if (x)  // x!=NULL
    {
        free(x->t);
        free(x);
    }
}

int main()
{
    matrice *a = citeste();
    matrice *b = citeste();
    matrice *c = suma(a,b);
    afiseaza(c);
    dezaloca(a);
    dezaloca(b);
    dezaloca(c);
    return 0;
}
